<%--
$Id$

CDDL HEADER START

The contents of this file are subject to the terms of the
Common Development and Distribution License (the "License").
You may not use this file except in compliance with the License.

See LICENSE.txt included in this distribution for the specific
language governing permissions and limitations under the License.

When distributing Covered Code, include this CDDL HEADER in each
file and include the License file at LICENSE.txt.
If applicable, add the following below this CDDL HEADER, with the
fields enclosed by brackets "[]" replaced with your own identifying
information: Portions Copyright [yyyy] [name of copyright owner]

CDDL HEADER END

Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
Use is subject to license terms.

Portions Copyright 2011 Jens Elkner.

--%><%@page import="
java.io.File,
java.io.FileInputStream,
java.io.InputStream,
java.io.OutputStream,

org.opensolaris.opengrok.history.HistoryGuru,
org.opensolaris.opengrok.util.IOUtils,
org.opensolaris.opengrok.web.PageConfig"
%><%@

include file="pageconfig.jspf"

%><%
/* ---------------------- raw.jsp start --------------------- */
{
    cfg = PageConfig.get(request);
    String redir = cfg.canProcess();
    if (redir == null || redir.length() > 0) {
        if (redir != null) {
            response.sendRedirect(redir);
        } else {
            response.sendError(HttpServletResponse.SC_NOT_FOUND);
        }
        return;
    }

	File f = new File(cfg.getSourceRootPath() + '/' + cfg.getPath());
	String revision = cfg.getRequestedRevision();
	if (revision.length() == 0) {
		revision = null;
	}
	int b = -1;
	InputStream in = null;
	try {
		if (revision != null) {
			in = HistoryGuru.getInstance().getRevision(f.getParent(),
				f.getName(), revision.substring(2));
			// it might be a virtual file - History guru does not provide 
			// sufficient info to detect in a reliable way
			in.mark(2);
			b = in.read();
			in.reset();
		} else {
			long flast = f.lastModified()/1000 * 1000;
			long lmdate = cfg.getConfig().getLastModified();
			if (lmdate > flast) {
				flast = lmdate;
			}
			if (request.getDateHeader("If-Modified-Since") >= flast) {
				response.setStatus(HttpServletResponse.SC_NOT_MODIFIED);
				return;
			}
			in = new FileInputStream(f);
			response.setContentLength((int) f.length());
			response.setDateHeader("Last-Modified", flast);
			b = 0;
		}
	} catch (Exception e) {
		IOUtils.close(in); // can't do that in finally - in still needed
	}
	if (b == -1) {
		response.sendError(HttpServletResponse.SC_NOT_FOUND);
		return;
	}
	String mimeType = getServletContext().getMimeType(f.getPath());
	response.setContentType(mimeType);

	try {
		response.setHeader("content-disposition", "attachment; filename="
			+ f.getName());
		OutputStream o = response.getOutputStream();
		byte[] buffer = new byte[8192];
		int nr;
		while ((nr = in.read(buffer)) > 0) {
			o.write(buffer, 0, nr);
		}
		o.flush();
		o.close();
	} finally {
		IOUtils.close(in);
	}
}
/* ---------------------- raw.jsp end-------------------- */
%>